=== debian/changelog ===
libmmmulti (0.1-4) unstable; urgency=medium

  * Team upload.
  * cmake-4.patch: new: bump minimum cmake to 3.10. (Closes: #1113174)
  * d/watch: bump to v5 Github template.
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.

 -- Étienne Mollier <emollier@debian.org>  Thu, 02 Oct 2025 21:51:21 +0200

libmmmulti (0.1-3) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.6.2 (routine-update)
  * d/clean: Remove generated bin/ directory (Closes: #1048502)
  * d/salsa-ci.yml: Disable i386 builds, since some build depends are not
    installable (libatomic-queue-dev and libsdsl-dev)

 -- Lance Lin <lq27267@gmail.com>  Thu, 21 Dec 2023 19:41:36 +0700

libmmmulti (0.1-2) unstable; urgency=medium

  * Source-only-upload.

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 29 Oct 2020 19:01:43 +0530

libmmmulti (0.1-1) unstable; urgency=medium

  * Initial release (Closes: #963718)

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 25 Jun 2020 18:14:01 +0200
