=== debian/watch ===
Version: 5

Template: Github
Owner: ekg
Project: mmmulti
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%mmmulti-$1.tar.gz%
